/*--------------------------------------------------------------------------+
$Id: codetemplates.xml 1 2011-01-01 00:00:01Z hoelzl $
|                                                                          |
| Copyright 2013 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.base.ui.databinding;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.ColumnViewer;
import org.eclipse.swt.widgets.Composite;
import org.fortiss.tooling.base.ui.editor.TextCellEditorWithTextStyledTextActionHandler;
import org.fortiss.tooling.kernel.ui.extension.base.EditorBase;

/**
 * TODO(VA): Comment?
 * TODO(VA): Many similarities with AbstractTextCellWithTextStyledblah, should be factorized.
 * 
 * @author czhang
 * @author $Author: hoelzl $
 * @version $Rev: 18709 $
 * @ConQAT.Rating RED Hash:
 */
public abstract class AbstractComplexCellWithTextStyledTextActionHandlerDatabindingEditingSupport
		extends AbstractComplexCellDatabindingEditingSupport {

	/** Editor, which contains this EditingSupport} */
	protected EditorBase<? extends EObject> editor;

	/** Constructor. */
	public AbstractComplexCellWithTextStyledTextActionHandlerDatabindingEditingSupport(
			EditorBase<? extends EObject> editor, ColumnViewer viewer,
			DataBindingContext bindingContext) {
		super(viewer, bindingContext);
		this.editor = editor;
	}

	/** {@inheritDoc} */
	@Override
	protected CellEditor createTextCellEditor(ColumnViewer viewer) {
		CellEditor cellEditor =
				new TextCellEditorWithTextStyledTextActionHandler(
						editor.getTextStyledTextActionHandler(), (Composite)getViewer()
								.getControl());
		setupCellEditor(cellEditor);
		return cellEditor;
	}
}
