/*-------------------------------------------------------------------------+
|                                                                          |
| Copyright 2005-2011 The ConQAT Project                                   |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+-------------------------------------------------------------------------*/
package org.conqat.ide.commons.ui.swt;

import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Display;

import org.conqat.lib.commons.assertion.CCSMAssert;

/**
 * Common lengthy {@link Font} operations made short.
 * 
 * @author schwitze
 * @author $Author: deissenb $
 * @version $Rev: 34252 $
 * @levd.rating GREEN Hash: 84D27E4E7A7826E1E74E0094F321E3CB
 */
public class FontUtils {

	/**
	 * Returns a new {@link Font} derived from the given font. The original
	 * height is changed by deltaHeight and the given style is set.
	 */
	public static Font derive(Font font, int deltaHeight, int style) {
		FontData[] fontDatas = font.getFontData();
		CCSMAssert.isTrue(fontDatas.length > 0, "Expected at least 1 FontData");
		FontData fd = fontDatas[0];
		return new Font(Display.getDefault(), fd.getName(), fd.getHeight()
				+ deltaHeight, style);

	}

}